
"""
Movie recommender system as a showcase project
"""

import collections
import pandas as pd
# import tensorflow as tf

def load_movielense():
    """Load an return movies and ratings as dataframes"""
    ratings_filename = "MovieLense20M/rating.csv"
    ratings_df = pd.read_csv(ratings_filename)

    movies_filename = "MovieLense20M/movie.csv"
    movies_df = pd.read_csv(movies_filename)

    return ratings_df, movies_df

def collect_user_context(ratings, min_rating=2.1):
    """Create a per-user rating list"""
    user_movies = collections.defaultdict(lambda: [])  # dict mapping ids to movies

    ratings = ratings.sort_values(by=['userId', 'timestamp'])

    for user_id, movie_id, rating, _ in ratings.values:
        if rating >= min_rating:
            user_movies[user_id].append(movie_id)

    return user_movies
